# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetZoneSubscriptionResult',
    'AwaitableGetZoneSubscriptionResult',
    'get_zone_subscription',
    'get_zone_subscription_output',
]

@pulumi.output_type
class GetZoneSubscriptionResult:
    """
    A collection of values returned by getZoneSubscription.
    """
    def __init__(__self__, id=None, identifier=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if identifier and not isinstance(identifier, str):
            raise TypeError("Expected argument 'identifier' to be a str")
        pulumi.set(__self__, "identifier", identifier)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def identifier(self) -> builtins.str:
        """
        Subscription identifier tag.
        """
        return pulumi.get(self, "identifier")


class AwaitableGetZoneSubscriptionResult(GetZoneSubscriptionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZoneSubscriptionResult(
            id=self.id,
            identifier=self.identifier)


def get_zone_subscription(identifier: Optional[builtins.str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZoneSubscriptionResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zone_subscription = cloudflare.get_zone_subscription(identifier="506e3185e9c882d175a2d0cb0093d9f2")
    ```


    :param builtins.str identifier: Subscription identifier tag.
    """
    __args__ = dict()
    __args__['identifier'] = identifier
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getZoneSubscription:getZoneSubscription', __args__, opts=opts, typ=GetZoneSubscriptionResult).value

    return AwaitableGetZoneSubscriptionResult(
        id=pulumi.get(__ret__, 'id'),
        identifier=pulumi.get(__ret__, 'identifier'))
def get_zone_subscription_output(identifier: Optional[pulumi.Input[builtins.str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetZoneSubscriptionResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zone_subscription = cloudflare.get_zone_subscription(identifier="506e3185e9c882d175a2d0cb0093d9f2")
    ```


    :param builtins.str identifier: Subscription identifier tag.
    """
    __args__ = dict()
    __args__['identifier'] = identifier
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getZoneSubscription:getZoneSubscription', __args__, opts=opts, typ=GetZoneSubscriptionResult)
    return __ret__.apply(lambda __response__: GetZoneSubscriptionResult(
        id=pulumi.get(__response__, 'id'),
        identifier=pulumi.get(__response__, 'identifier')))
